{This file was processed by Dan's Source Converter}
{version 1.3 (this version modified by Ingemar Ragnemalm)}

program MPHelloWorld;

uses
Types, QuickDraw, Events, Windows, Dialogs, Fonts, DiskInit, TextEdit, Traps,{}
Memory, SegLoad, Scrap, ToolUtils, OSUtils, Menus, Resources, StandardFile,{}
GestaltEqu , Files , Errors , Devices , QuickDrawText , TextUtils,MP; {}

{End of standard head. Add more units to uses as necessary.}

var
	err:Integer;
	
{------------------------------------------------------------------------}
procedure InitMac;
{------------------------------------------------------------------------}
begin
	InitGraf(@qd.thePort);
	InitFonts; { foreground only }
	InitWindows; { foreground only }
	InitMenus; { foreground only }
	TEInit; { foreground only }
	InitDialogs(nil); { foreground only }
	{SetApplLimit(sp-stack_size);}
	MaxApplZone;
	MoreMasters;
	MoreMasters;

end;


{------------------------------------------------------------------------}
 procedure sendString(queue:MPQueueID; Var theString:Str255); 
{------------------------------------------------------------------------}
{  Send the string through the queue one character at a time.}
  var
  	err:OSStatus;
   	i:integer;
   	theChar:char;
   begin 
	
	for i:= 1 to integer(theString[0]) do
	begin 
		theChar :=thestring[i];
		err:= MPNotifyQueue(queue,longint(theChar), nil, nil);
    end;
	theChar :=chr(0);
	err:= MPNotifyQueue(queue,longint(theChar),nil, nil);			(* Send the final null character. *)
 End;


{------------------------------------------------------------------------}
 procedure receiveString(queue:MPQueueID; Var thestring:Str255); 
{------------------------------------------------------------------------}
{  Reassemble a string being transferred over the queue and return it to the caller.}
  var     
	 first:longint;			{* The first word of the message. *}
	 second:longint;		{* The second word of the message. *}
	 third:longint;			{* The third word of the message. *}
	i:integer;
	err:integer;
	
begin 
	i:=1;
	while(true) do
	begin 
		err:= MPWaitOnQueue(queue, @first, @second, @third, kDurationForever);
		
		If  (first = 0) Then 
			begin
				theString[0] := char(i-1);
				exit(receiveString);
			end
		else
			begin
				theString[i] := char(first);
			end;
		i:=i+1;
	End;
End;


{------------------------------------------------------------------------}
 function HelloWorld( parameter:MPQueueID):OSStatus; 
{------------------------------------------------------------------------}
  var    
   queue :MPQueueID;
	tempStr:Str255;
   begin 
    queue := parameter;
    tempStr:='Hello, World from Pascal!';
    
	sendString(queue, tempStr);

  	HelloWorld:= noErr;
 End;


{------------------------------------------------------------------------}
 function failure(Var annotation:Str255;  routine:Str255; status:OSStatus):Integer; 
{------------------------------------------------------------------------}
 var
 tempStr:Str255;
 itemHit:integer;
   begin 
(*	printf('Uh oh.  %s%s%s returned %s [%d].\n',
         (annotation) ? annotation : '',
         (routine) ? routine : '',
         (routine) ? '()' : 'A routine',
         _MPStatusCString(status),
         status);
*)

	
{}
	{tempStr:=_MPStatusPString(status);}
	
	DebugStr(annotation);
	
{	ParamText(tempStr,'','','');}
{	itemHit:=Alert(128,nil);}
	
  failure:= 1;
 End;


{------------------------------------------------------------------------}
 function Test:Integer; 
{------------------------------------------------------------------------}
  var     
	status,err:OSStatus;					(* We'll use this to test the outcome of each MP function. *)
	terminationQueue:MPQueueID;		(* This queue will report the completion of the task. *)
	communicationQueue:MPQueueID;		(* This queue will be used to communicate between the app and the task. *)
	task:MPTaskID;					(* This will be the ID of the task we create. *)
	myString:Str255;
	itemHit:Integer;
	tempStr:Str255;
	
   begin 

  	If  (Not MPLibraryIsLoaded) Then 
     begin 
		ParamText('Can''t run without the ',MPLibraryPName,' shared library.','');
		itemHit:=Alert(129,nil);
    	exit(Test);
   	End;
   	

  status := MPCreateQueue(terminationQueue);	(* Create the queue which will report the completion of the task. *)
  If  (status <> noErr) Then 
	Begin 	  
		tempStr:='Cannot create the termination queue:\n';
    	Test:= failure(tempStr, "MPCreateQueue", status);
		Exit(Test);
	End;

  status := MPCreateQueue(communicationQueue);	(* Create the queue we'll use to communicate with. *)
  If  (status <> noErr) Then 
   	begin 
   		err:=MPDeleteQueue(terminationQueue);
		tempStr:='Cannot create the communication queue:\n    ';
    	Test:=failure(tempStr, 'MPCreateQueue', status);
    	exit(Test);
   end;

  status := MPCreateTask(HelloWorld,				(* This is the task function. *)
                        communicationQueue,		(* This is the parameter to the task function. *)
                        kMPUseDefaultStackSize,	(* We'll use whatever the MP system software gives us. *)
                        terminationQueue,		(* We'll use this to sense task completion. *)
                        nil,						(* We won't use the first part of the termination message. *)
                        nil,						(* We won't use the second part of the termination message. *)
						kMPNormalTaskOptions,	(* Use the normal task options. (Currently this *must* be zero!) *)
						task);					(* Here's where the ID of the new task will go. *)

  If  (status <> noErr) Then 
	begin 
		err:= MPDeleteQueue(terminationQueue);
		err:= MPDeleteQueue(communicationQueue);
		tempStr:='';
		Test := failure(tempStr, 'MPCreateTask', status);
		exit(Test);
	End;

  receiveString(communicationQueue, myString);
  ParamText(myString,'brought to you by Matthew Xavier Mora mxmora@apple.com','Developer Technical Support,','MW Pascal and MP.p interfaces');
  
	itemHit:=Alert(128,nil);

  (* Wait for the task to complete: *)
  status := MPWaitOnQueue(terminationQueue, nil, nil, nil, kDurationForever);
  If  (status <> noErr) Then 
   begin 
   	tempStr:='While waiting for task completion:\n    ';
	err:= failure(tempStr, 'MPWaitOnQueue', status);
   end;

  status := MPDeleteQueue(terminationQueue);
  if  (status <> noErr) Then 
     begin 
     	tempStr:='Can''t delete the termination queue:';
	err:= failure(tempStr, 'MPDeleteQueue', status);
   end;

  status := MPDeleteQueue(communicationQueue);
  If  (status <> noErr) Then 
    begin 
    	tempStr:='Can''t delete the communication queue: ';
		err:= failure(tempStr, 'MPDeleteQueue', status);
   end;

   Test:= 0;
	Exit(Test);
 End;
begin
	InitMac;

	err:=Test;

end.
